/**
 * Diese Klasse repraesentiert eine 2x2-Matrix mit Hilfe von
 * vier Elementvariablen.
 * @author Peter Schneider-Kamp
 * @version 25.11.2003, 12:14
 */
public class Matrix {

    /**
     * Die vier Elemente a, b, c und d repraesentieren
     * die Matrix mit 1. Zeile a b und 2. Zeile c d.
     */
    private Element a, b, c, d;

    /**
     * Diese Methode setzt Breite und Hoehe dieser Matrix.
     * @param breite Breite dieser Matrix.
     * @param hoehe Hoehe dieser Matrix.
     */
    public void setDimension(int breite, int hoehe) {
        if (breite != 2 || hoehe !=2 ) {
            System.err.println("Unterstuetze nur 2-dimensionale Matrizen!");
        }
    }

    /**
     * Diese Methode gibt die Breite dieser Matrix zurueck.
     * @return Breite dieser Matrix.
     */
    public int getWidth() {
        return 2;
    }

    /**
     * Diese Methode gibt die Hoehe dieser Matrix zurueck.
     * @return Hoehe dieser Matrix.
     */
    public int getHeight() {
        return 2;
    }

    /**
     * Diese Methode liefer den wert des Elementes einer bestimmten Position.
     * @param x Spalte der Position.
     * @param y Zeile der Position.
     * @return Wert, den das Element an der Position x,y besitzt.
     */
    public Element getElement(int x, int y) {
        if (x == 0) {
            if (y == 0) {
                return a;
            } else if (y == 1) {
                return c;
            }
        } else if (x == 1) {
            if (y == 0) {
                return b;
            } else if (y == 1) {
                return d;
            }
        }
        System.err.println("Unterstuetze nur 2-dimensionale Matrizen!");
        return new Element();
    }

    /**
     * Diese Methode setzt das Element an einer bestimmten Position
     * auf den gegebenen Wert.
     * @param x Spalte der Position.
     * @param y Zeile der Position.
     * @param wert Wert, den das Element an der Position x,y bekommen soll.
     */
    public void setElement(int x, int y, Element wert) {
        if (x == 0) {
            if (y == 0) {
                a = wert;
                return;
            } else if (y == 1) {
                c = wert;
                return;
            }
        } else if (x == 1) {
            if (y == 0) {
                b = wert;
                return;
            } else if (y == 1) {
                d = wert;
                return;
            }
        }
        System.err.println("Unterstuetze nur 2-dimensionale Matrizen!");
    }

    /**
     * Diese Methode erstellt eine Stringdarstellung dieser Matrix.
     * @return Eine Stringdarstellung dieser Matrix.
     */
    public String toString() {
        return ""+a+" "+b+"\n"+c+" "+d+"\n";
    }

}
