/**
 * Diese Klasse repraesentiert eine nxm-Matrix mit Hilfe
 * eines zweidimensionalen Arrays.
 * @author Peter Schneider-Kamp
 * @version 25.11.2003, 12:12
 */
public class Matrix {

    /**
     * Das zweidimensionale Array repraesentiert Spalten
     * und Zeilen der Matrix.
     */
    private Element[][] elemente;

    /**
     * Diese Methode setzt Breite und Hoehe dieser Matrix.
     * @param breite Breite dieser Matrix.
     * @param hoehe Hoehe dieser Matrix.
     */
    public void setDimension(int breite, int hoehe) {
        this.elemente = new Element[breite][hoehe];
    }

    /**
     * Diese Methode gibt die Breite dieser Matrix zurueck.
     * @return Breite dieser Matrix.
     */
    public int getWidth() {
        return this.elemente.length;
    }

    /**
     * Diese Methode gibt die Hoehe dieser Matrix zurueck.
     * @return Hoehe dieser Matrix.
     */
    public int getHeight() {
        if (this.getWidth() == 0) {
            return 0;
        } else {
            return this.elemente[0].length;
        }
    }

    /**
     * Diese Methode liefer den wert des Elementes einer bestimmten Position.
     * @param x Spalte der Position.
     * @param y Zeile der Position.
     * @return Wert, den das Element an der Position x,y besitzt.
     */
    public Element getElement(int x, int y) {
        return elemente[x][y];
    }

    /**
     * Diese Methode setzt das Element an einer bestimmten Position
     * auf den gegebenen Wert.
     * @param x Spalte der Position.
     * @param y Zeile der Position.
     * @param wert Wert, den das Element an der Position x,y bekommen soll.
     */
    public void setElement(int x, int y, Element wert) {
        elemente[x][y] = wert;
    }

    /**
     * Diese Methode erstellt eine Stringdarstellung dieser Matrix.
     * @return Eine Stringdarstellung dieser Matrix.
     */
    public String toString() {
        String ausgabe = "";
        for (int j = 0; j < getHeight(); j++) {
            for (int i = 0; i < getWidth(); i++) {
                if (i > 0)
                    ausgabe += " ";
                ausgabe += getElement(i, j);
            }
            ausgabe += "\n";
        }
        return ausgabe;
    }

}
