/**
 * Diese Klasse repraesentiert eine Fliesskommazahl.
 * @author Peter Schneider-Kamp
 * @version 25.11.2003, 12:24
 */
public class Element {

    /**
     * Die Fliesskommazahl wird als double gespeichert.
     */
    private double wert;

    /**
     * Diese Methode setzt den Wert der Klasse auf
     * das Nullelement.
     */
    public void setZero() {
        this.wert = 0.0;
    }

    /**
     * Diese Methode berechnet die Summe von zwei Elementen.
     * Dabei wird ein neues Element erzeugt, d.h., die bergebenen
     * Elemente werden nicht gendert.
     * @param b Der zweite Summand des Summe.
     * @return Die Summe der beiden Elemente.
     */
    public Element add(Element b) {
        Element ergebnis = new Element();
        ergebnis.wert = wert + b.wert;
        return ergebnis;
    }

    /**
     * Diese Methode berechnet das Produkt von zwei Elementen.
     * Dabei wird ein neues Element erzeugt, d.h., die bergebenen
     * Elemente werden nicht gendert.
     * @param b Der zweite Multiplikand des Produktes.
     * @return Das Produkt der beiden Elemente.
     */
    public Element multiply(Element b) {
        Element ergebnis = new Element();
        ergebnis.wert = wert * b.wert;
        return ergebnis;
    }

    /**
     * Diese Methode liest ein Element ein.
     * @return Das eingelesene Element.
     */
    public static Element read() {
        Element ergebnis = new Element();
        ergebnis.wert = IO.readDouble();
        return ergebnis;
    }

    /**
     * Diese Methode erstellt eine Stringdarstellung dieses Elementes.
     * @return Eine Stringdarstellung dieses Elementes.
     */
    public String toString() {
        return "" + wert;
    }

}
